#pragma once

#include <iostream>
#include <string>
#include <memory>
#include <vector>

using content = std::string;
using ref     = std::shared_ptr<content>;
using ref_set = std::vector<ref>;

// ==== Part 1, question 1 code hereafter

// Nothing to be done here.
ref make_ref(const std::string& value);
std::ostream& operator<<(std::ostream& os, const ref_set& rs);

// ==== Part 1, question 2 code hereafter

ref_set empty_set();
bool    has(const ref_set& the_set, ref elem); // Use a reference to avoid useless copy, and a const one is better.

// ==== Part 1, question 3 code hereafter


void insert(ref_set& the_set, ref elem);     // Use a reference to enable modification of the_set by the function, not const of course.
void operator+=(ref_set& the_set, ref elem); // Same header than insert here.
void remove_duplicates(ref_set& the_set);    // Type for 'the_set' argument is missing.

#endif // End of Part 1, question 3 code


// ==== Part 1, question 4

////// use const references.
ref_set operator||(const ref_set& A, const ref_set& B);
ref_set operator&&(const ref_set& A, const ref_set& B);
bool    operator==(const ref_set& A, const ref_set& B);
