#include <iostream>
#include <string>
#include "part2.hpp"

std::string to_upper(const std::string& s) {
  auto res = s;
  for (auto & c: res) c = std::toupper(c);
  return res;
}

int main(int argc, char* argv[]) {
  
  auto ta  = ref_set::make_ref("ta");
  auto to  = ref_set::make_ref("toto");
  auto TO  = ref_set::make_ref("toTo");
  auto ti  = ref_set::make_ref("tititi");
  auto tu  = ref_set::make_ref("tu");
  auto tut = ref_set::make_ref("TU");

  ref_set A {ta, to, ti, tu, tut, TO};

  // if A is {x, y, z}, A.apply(f) is {f(x), f(y), f(z)}.
  ref_set B = A.apply([](const std::string& s) {return to_upper(s) + "=" + std::to_string(s.size());});

  // The order in the inputs is allowed to be different for you.
  std::cout << A << std::endl  // Output : {ta, toto, tititi, tu, TU, toTo}
	    << B << std::endl; // output : {TA=2, TOTO=4, TITITI=6, TU=2}

  return 0;
}
