#pragma once

#include <iostream>
#include <string>
#include <memory>
#include <vector>
#include <initializer_list>

// Questions 1 and 2 of part 2 makes you complete this file (and
// eventually part2.cpp).  The basic idea here is to implement what
// has been developped in part 1, as methods of the class ref_set
// here, working on the data attribute.
//
// All the function in part1.hpp and part1.cpp have to be implemented
// here as methods (except insert, we prefer +=). Copy-pasting from
// part1 does most of the job.
// from part1 does most of the job.

class ref_set {
public:
  using content_type = std::string;
  using ref_type     = std::shared_ptr<content_type>;

private:

  std::vector<ref_type> data;
  
public:

  ref_set()                          = default;
  ref_set(const ref_set&)            = default;
  ref_set(ref_set&&)                 = default;
  ref_set& operator=(const ref_set&) = default;
  ref_set& operator=(ref_set&&)      = default;

  // Let is keep remove_duplicate for internal use.

  ref_set(const std::initializer_list<ref_type>& data); // enables ref_set A {..., ..., ...};

};
