#include <iostream>
#include "part3.hpp"

int main(int argc, char* argv[]) {

  // The power set of a set is the set of all its subsets, including
  // the empty set.  In this question, we implement the power_set
  // method. For example:
  // power_set({a, b, c}) = {{},     {b},    {c},    {b, c},
  //                         {a}, {a, b}, {a, c}, {a, b, c}}
  
  // #### Hint ####
  //
  // Implement an recursive approch. Indeed, for computing the
  // power_set({a, b, c}), you can call the function itself to compute
  // power_set({b, c}), which gives you {{}, {b}, {c}, {b, c}}. This is
  // one half of the result. The other half is obtained by adding 'a' in
  // all the sets of the first half. 
  //
  // Be carfull, power_set({}) = {{}}, not {} !
  
  ref_set<char> A {ref_set<char>::make_ref('a'),
		   ref_set<char>::make_ref('b'),
		   ref_set<char>::make_ref('c')};
  auto B = A.power_set();

  // You may have the same content, but in a different order.
  std::cout << A << std::endl  // Output : {a, b, c}
	    << B << std::endl; // output : {{}, {c}, {b}, {c, b}, {a}, {c, a}, {b, a}, {c, b, a}}

  ref_set<char> a {ref_set<char>::make_ref('a')};
  auto b = a.power_set();
  auto c = b.power_set();

  // You may have the same content, but in a different order.
  std::cout << a << std::endl  // Output : {a}
	    << b << std::endl  // Output : {{}, {a}}
	    << c << std::endl; // output : {{}, {{a}}, {{}}, {{a}, {}}}
  return 0;
}
